%global okauth_user_grp     okauth
%global okauth_dir          /var/lib/okauth
%global _unitdir            %{_libdir}/systemd/system
%global cacert_src          /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem
%global cacert_dst          /etc/ssl/cert.pem

Name:       okauth
Version:    %(cat version)
Release:    1%{?dist}
Summary:    Identity manager and authentication server
License:    EUPL-1.2
URL:        http://www.nkly.me/projects/okauth

Requires: ca-certificates

%description
OkAuth is an identity manager and authentication server. It is similar to
OpenID, but has important differences because it is intended to be used
in small controlled self-hosted setups.

%prep
%setup -q

%build
eval $(opam env)
make install-deps
make build-static man

%install
rm -rf %{buildroot}
install -s -D -m 0755 _build/default/src/okauthadm/okauthadm.exe %{buildroot}/%{_bindir}/okauthadm
install -s -D -m 0755 _build/default/src/okauthd/okauthd.exe %{buildroot}/%{_bindir}/okauthd
install -D -m 0644 man/okauthadm.8.gz %{buildroot}/%{_mandir}/man8/okauthadm.8.gz
install -D -m 0644 man/okauthd.8.gz %{buildroot}/%{_mandir}/man8/okauthd.8.gz
install -D -m 0644 dist/okauthd.conf %{buildroot}/%{_sysconfdir}/okauthd.conf
install -D -m 0644 dist/okauthd.service %{buildroot}/%{_unitdir}/okauthd.service

%pre
getent group %{okauth_user_grp} >/dev/null 2>&1 \
    || groupadd --system %{okauth_user_grp}
getent passwd %{okauth_user_grp} >/dev/null 2>&1 \
    || useradd --system \
               --create-home \
               --home-dir %{okauth_dir} \
               --shell /sbin/nologin \
               --comment "OkAuth Daemon" \
               --gid %{okauth_user_grp} \
               %{okauth_user_grp}
mkdir -p "$(dirname %{cacert_dst})"
[[ "$(readlink %{cacert_dst})" == "%{cacert_src}" ]] || ln -s %{cacert_src} %{cacert_dst}

%post
chmod 0750 %{okauth_dir}
su -s /bin/sh %{okauth_user_grp} -c "cd %{okauth_dir} && okauthadm init"
chmod 0660 %{okauth_dir}/okauth.db

%preun
# Disable service on removal
if [ $1 -eq 0 ]; then systemctl --no-reload disable --now okauthd.service; fi

%files
%{_bindir}/okauthadm
%{_bindir}/okauthd
%{_mandir}/man8/okauthadm.8.gz
%{_mandir}/man8/okauthd.8.gz
%{_unitdir}/okauthd.service
%config(noreplace) %{_sysconfdir}/okauthd.conf

%changelog
# See project changelog
