# NAME

okauthd - OkAuth web daemon

# SYNOPSIS

**okauthd**

# DESCRIPTION

The OkAuth web daemon is a web-server that awaits requests from third-party apps
and performs authentication. It reads information about registered users and
approved applications from the file under _$DB_PATH_. This file is initialized
and managed by _okauthadm(8)_ tool.

The daemon is HTTP-only. It should be put behind an HTTPS-proxy to protect
sensitive user data from leaking.

# ENVIRONMENT

_$DB_PATH_
> Path to a database file. Default: _okauth.db_ file in the current working
> directory.

_$HOST_,
_$PORT_
> IP address and port to bind the HTTP-server to. Default: 127.0.0.1:4243.

# FILES

_okauth.db_ (if $DB_PATH is unset)
> Database file that keeps information about users, approved applications and
> their keys.

# SEE ALSO

**okauthadm**(8)

# RESOURCES

**Project homepage:** http://www.nkly.me/projects/okauth

# AUTHORS

Copyright (C) 2019 Nikolai Obedin.

Free use of this software is granted under the terms of EUPL-1.2.
