module type Storage = sig
  type t

  val find : t -> key:string -> string option

  val set : t -> key:string -> value:string -> unit

  val remove : t -> key:string -> unit
end

module type S = sig
  type storage

  val middleware : storage Config.t -> Okweb.Middleware.t
end
