open Okweb

let config =
  let open Okcrypto in
  let open Okauth_client in
  let base_url = "http://localhost:4299" in
  let app_name = "Example OkAuth Client App" in
  let public_encryption_key =
    Public_key.of_base64_exn "8l0sosqd_saZLdPnhO-WJIgY0IcoA_KAoML7S-diZ30"
  in
  let secret_encryption_key =
    Secret_key.of_base64_exn "g5f10CiEXaFObI_sE3sTCKf_bhhCdOIYlRm1RdrV47A"
  in
  let public_signing_key =
    Public_key.of_base64_exn "N8uUMJR7u6UXs4pZl4acBqMXWQ7h8Z-KJNU5RWfVu8s"
  in
  let secret_signing_key =
    Secret_key.of_base64_exn
      "oDltqVGvZI9oy-0MAipFbJ6ws1kT2XWwBhq3pQZsn6I3y5QwlHu7pRezilmXhpwGoxdZDuHxn4ok1TlFZ9W7yw"
  in
  let storage = In_memory_storage.empty in
  Config.make ~base_url ~app_name ~public_encryption_key ~secret_encryption_key
    ~public_signing_key ~secret_signing_key storage

let process_request _ = Lwt.return Response.(ok |> with_string_body "It works!")

let () =
  let address, port = ("localhost", 4299) in
  let module C =
    Okauth_client.Make (Okweb.Client) (Okauth_client.In_memory_storage)
  in
  let handler = C.middleware config process_request in
  Stdio.prerr_endline (Printf.sprintf "Listening on %s:%d" address port);
  Lwt_main.run (Server.listen ~address ~port handler)
